#if !defined(AFX_MENUMEANDIURNALVARIATIONDLG_H__9DC86367_97D0_41C4_98AD_26ECE0E9BBB5__INCLUDED_)
#define AFX_MENUMEANDIURNALVARIATIONDLG_H__9DC86367_97D0_41C4_98AD_26ECE0E9BBB5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MenuMeanDiurnalVariationDlg.h : wb_[ t@C
//
#include "MeanTerm.h"
#include <vector>
/////////////////////////////////////////////////////////////////////////////
// CMenuMeanDiurnalVariationDlg _CAO

class CMenuMeanDiurnalVariationDlg : public CDialog
{
// RXgNV
public:
	CMenuMeanDiurnalVariationDlg(CWnd* pParent = NULL);   // W̃RXgN^

	BOOL ReadFile_with_MovingWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm, CString& strHeaderLine);
	BOOL ReadFile_with_BlockWindow (CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm, CString& strHeaderLine);

	BOOL MeanDiurnalVariation(const CString& strOutDir, std::vector<CMeanTerm*>& aryMeanTerm, CString& strHeaderLine, BOOL bMovingAverage, CProgressCtrl& ctlProgress);
	void SetForBatchSetting(const CString& strIniFile, const CString& strInputFile, const CString& strOutputDir);
	
	BOOL OnMeanDiurnalVariation(CString& strErrorMessage);
	BOOL SetParameterFromFile(CString strFilePass);

// _CAO f[^
	//{{AFX_DATA(CMenuMeanDiurnalVariationDlg)
	enum { IDD = IDD_DLG_MDV };
	CProgressCtrl	m_ctlProgress;
	CString	m_strInputFile;
	CString	m_strOutputFile;
	UINT	m_iGapFillingTerm;
	UINT	m_iRunPerDay;
	UINT	m_iMaximumForLinearRegression;
	BOOL	m_bUsePeriod;
	BOOL	m_bMovingAverage;
	BOOL	m_bUseLinearRegression;
	BOOL	m_bIsBootstrap;
	UINT	m_iBootstrapNum;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CMenuMeanDiurnalVariationDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	CString m_strInputTitle;
	CString m_strErrorMessage;
	int m_iLineNum;

	BOOL ErrorCheck(CString& strErrorMessage);

	CWinThread* m_pThread;
	BOOL m_bIsThread;
	static UINT OnMeanDiurnalVariationThread(LPVOID pParam);
//	BOOL IsActiveThread() { return m_bIsThread; }
	CString m_strErrorMessageForThread;

	void SaveSetting(const CString& strFilePass);

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CMenuMeanDiurnalVariationDlg)
	afx_msg void OnKillfocus();
	afx_msg void OnButtonInputFile();
	afx_msg void OnButtonFixedData();
	afx_msg void OnButtonApply();
	virtual BOOL OnInitDialog();
	afx_msg void OnCheckUseRegression();
	afx_msg void OnBtnSave();
	afx_msg void OnBtnLaod();
	afx_msg void OnCheckBootstrap();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_MENUMEANDIURNALVARIATIONDLG_H__9DC86367_97D0_41C4_98AD_26ECE0E9BBB5__INCLUDED_)
