#if !defined(AFX_QCQADLG_H__E1E0CC54_897E_485B_A561_A4D0192D1CD9__INCLUDED_)
#define AFX_QCQADLG_H__E1E0CC54_897E_485B_A561_A4D0192D1CD9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// QcQaDlg.h : wb_[ t@C
//
#include "MeanTerm.h"
#include <vector>
/////////////////////////////////////////////////////////////////////////////
// CQcQaDlg _CAO

class CQcQaDlg : public CDialog
{
// RXgNV
public:
	CQcQaDlg(CWnd* pParent = NULL);   // W̃RXgN^
	void public_OnBtnApply(CString& strError) {ApplyQualityControl(strError);};
	void SetForBatchSetting(const CString& strIniFile, const CString& strInputFile, const CString& strOutputDir);

// _CAO f[^
	//{{AFX_DATA(CQcQaDlg)
	enum { IDD = IDD_DLG_QC };
	CProgressCtrl	m_ctlProgress;
	CString	m_strInputFile;
	CString	m_strOutputDir;
	double	m_dZvalue;
	BOOL	m_bUsePeriod;
	int		m_iWindowSize;
	double	m_dNighttimeRadiation;
	BOOL	m_bIsDayNightDiv;
	int		m_iRadiationColumn;
	int		m_iRunPerDay;
	BOOL	m_bMovingAverage;
	BOOL	m_bIs2ndZvalue;
	double	m_d2ndZvalue;
	BOOL	m_bIsFluxPartitioningFile;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CQcQaDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	CString m_strInputTitle;
	CString m_strHeader;
	CString m_strHeader2;

	CWinThread* m_pThread;
	BOOL m_bIsThread;
	static UINT ApplyQualityControlThread(LPVOID pParam);
	CString m_strErrorMessageForThread;

	BOOL ApplyQualityControl(CString& strErrorMessage);
	BOOL QalityControl(const CString& strOutDir, std::vector<CMeanTerm*>& aryMeanTerm, CProgressCtrl& ctlProgress);
	BOOL ReadFile_with_BlockWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm);
	BOOL ReadFile_with_MovingWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm);
	BOOL ErrorCheck(CString& strErrorMessage);

	BOOL IsZeroValue(CString strValue);
	BOOL ReadPartitioningFile(const CString& strFileName, std::vector< std::vector<double> >& aryData, std::vector<CString>& aryDate, std::vector<CString>& aryHeaderString);
	BOOL WriteFluxPartitioningInputQC(const CString& strInputFile, const CString& strResultFile);

	void SaveSetting(const CString& strFilePass);
	BOOL SetParameterFromFile(CString strFilePass);

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CQcQaDlg)
	afx_msg void OnKillfocus();
	afx_msg void OnButtonInputFile();
	afx_msg void OnButtonFixedData();
	afx_msg void OnBtnApply();
	virtual BOOL OnInitDialog();
	afx_msg void OnCheckDivNight();
	afx_msg void OnCheck2ndZValue();
	afx_msg void OnBtnSave();
	afx_msg void OnBtnLaod();
	afx_msg void OnCheckFluxInput();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_QCQADLG_H__E1E0CC54_897E_485B_A561_A4D0192D1CD9__INCLUDED_)
