#if !defined(AFX_SELFCORRELATIONDLG_H__E7A0B392_D787_4506_8CB7_E355A7EAC616__INCLUDED_)
#define AFX_SELFCORRELATIONDLG_H__E7A0B392_D787_4506_8CB7_E355A7EAC616__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SelfCorrelationDlg.h : wb_[ t@C
//
#include <vector>
/////////////////////////////////////////////////////////////////////////////
// CSelfCorrelationDlg _CAO

class CSelfCorrelationDlg : public CDialog
{
// RXgNV
public:
	CSelfCorrelationDlg(CWnd* pParent = NULL);   // W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CSelfCorrelationDlg)
	enum { IDD = IDD_DLG_SELF_CORREL };
	CString	m_strInputFile;
	CString	m_strInputFlux;
	CString	m_strOutputDir;
	UINT	m_iIteration;
	UINT	m_iRunPerDay;
	BOOL	m_bUseDaytimeOnly;
	double	m_dNighttimeRadiation;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CSelfCorrelationDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	BOOL ReadFile_with_BlockWindow(CString& strInputFile, std::vector<CString>& aryLines);
	void GetDataFromLines(std::vector<CString>& aryLines, std::vector<double>& aryData, const int& iColumn, const double& dError);
	BOOL IsZeroValue(CString strValue);
	BOOL select_daytime_data(std::vector<double>& aryNEE, std::vector<double>& aryRE, std::vector<double>& aryGPP, std::vector<double>& aryPPFD, const double& dNighttimeRadiation);
	void caluculate_correlation_coefficient(const std::vector<double>& x, const std::vector<double>& y, double& dR);
	void caluculate_average_stdev(const std::vector<double>& x, double& average, double& stdev);
	void average_array(const std::vector<double>& aryIn1, const std::vector<double>& aryIn2, const std::vector<double>& aryIn3, 
		std::vector<double>& aryAverage1, std::vector<double>& aryAverage2, std::vector<double>& aryAverage3, const int& iAverageTerm);
	void make_randam_array(const std::vector<double>& aryIn, std::vector<double>& aryRondam);
	void make_bootstrap_array(const std::vector<double>& aryIn1, const std::vector<double>& aryIn2, const std::vector<double>& aryIn3, 
		std::vector<double>& aryInBootstrap1, std::vector<double>& aryInBootstrap2, std::vector<double>& aryInBootstrap3);
	void calculate_GPP(const std::vector<double>& aryNEE, const std::vector<double>& aryRE, std::vector<double>& aryGPP);
	void SaveSetting(const CString& strFilePass) ;
	BOOL SetParameterFromFile(CString strFilePass);
	BOOL ErrorCheck(CString& strErrorMessage);

	CString m_strInputTitle;
	static double s_dErrorValue;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CSelfCorrelationDlg)
	afx_msg void OnButtonInputFile();
	afx_msg void OnButtonInputFlux();
	afx_msg void OnButtonOutputDirecotry();
	afx_msg void OnButtonDetermine();
	afx_msg void OnKillfocus();
	afx_msg void OnCheckDaytime();
	virtual BOOL OnInitDialog();
	afx_msg void OnBtnLaod();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_SELFCORRELATIONDLG_H__E7A0B392_D787_4506_8CB7_E355A7EAC616__INCLUDED_)
