#if !defined(AFX_USTARFILTERINGDLG_H__D2A10700_C03C_4695_B1C3_A270E40E89D9__INCLUDED_)
#define AFX_USTARFILTERINGDLG_H__D2A10700_C03C_4695_B1C3_A270E40E89D9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// UstarFilteringDlg.h : wb_[ t@C
//
#include "MeanTerm.h"
#include <vector>
/////////////////////////////////////////////////////////////////////////////
// CUstarFilteringDlg _CAO

class CUstarFilteringDlg : public CDialog
{
// RXgNV
public:
	CUstarFilteringDlg(CWnd* pParent = NULL);   // W̃RXgN^

	void public_OnButtonDetermine() {OnButtonDetermine();};
	void SetForBatchSetting(const CString& strIniFile, const CString& strInputFile, const CString& strOutputDir);

// _CAO f[^
	//{{AFX_DATA(CUstarFilteringDlg)
	enum { IDD = IDD_DLG_U_STAR };
	CString	m_strInputFile;
	CString	m_strOutputDir;
	UINT	m_iTerm;
	UINT	m_iRunPerDay;
	BOOL	m_bUsePeriod;
	double	m_dNighttimeRadiation;
	double	m_dPvalue;
	UINT	m_iBootstrapNum;
	double	m_dUstarThres;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CUstarFilteringDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	CString m_strInputTitle;

	void average_stdev(const std::vector<double>& x, double& average, double& stdev);
	BOOL ErrorCheck(CString& strErrorMessage);
	BOOL ReadFile_with_BlockWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm, CString& strHeaderLine);

	void SaveSetting(const CString& strFilePass);
	BOOL SetParameterFromFile(CString strFilePass);

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CUstarFilteringDlg)
	afx_msg void OnKillfocus();
	afx_msg void OnButtonInputFile();
	afx_msg void OnButtonFixedData();
	afx_msg void OnButtonDetermine();
	virtual BOOL OnInitDialog();
	afx_msg void OnBtnLaod();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_USTARFILTERINGDLG_H__D2A10700_C03C_4695_B1C3_A270E40E89D9__INCLUDED_)
