// BrowseFolderDialog.h: CBrowseFolderDialog NX̃C^[tFCX
//
//		Reference : http://homepage2.nifty.com/soga/
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BROSEFOLDERDIALOG_H__20040211_UEYAMA__INCLUDED_)
#define AFX_BROSEFOLDERDIALOG_H__20040211_UEYAMA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CBrowseFolderDialog : public CWnd
{
public:
	CBrowseFolderDialog(UINT ulFlags = 0,LPCTSTR lpTitle = NULL,int iRootFolder = 0);
	virtual ~CBrowseFolderDialog();
	CString GetPathName( ) const;
	CString GetDirectoryName( ) const;
	int DoModal();
	int DoModal(LPCTSTR lpSelect);
	int DoModal(int iSelectFolder);

private:
	void Init();
	int Modal();
	static int CALLBACK CallBackFunc(HWND hwnd,UINT uMsg,LPARAM lParam,LPARAM lpData); // R[obN֐
	BOOL GetPIDL(int nFolder,LPITEMIDLIST *pidl);
	void FreePIDL(LPITEMIDLIST pidl);
	LPITEMIDLIST GetItemIDList( CString p_cFileStr );

	//  I[oChp
	virtual BOOL OnInitDialog(){return TRUE;}  
	virtual void OnChangedSel(HWND hwnd,LPITEMIDLIST pList); // IύX
	virtual void OnFailedValidate(LPCTSTR lpStr){} 

	LPITEMIDLIST m_rootPidl;          // [gtH_PIDL
	LPITEMIDLIST m_selectPidl;		  // ItH_PIDL	
	int m_iRootFolder;				  // [gtH_ ID
	int m_iSelectFolder;			  // ItH_

	char m_szFirstPath[MAX_PATH];     // ItH_pX
	char m_szDisplayName[MAX_PATH];   // I𕶎
	char m_szSelectedPath[MAX_PATH];  // ItpX	
	char m_szTitle[256];              // ^Cg̕
	UINT m_ulFlags;                   // \tO

	static char m_szText[MAX_PATH];

	//{{AFX_MSG(CBrowseFolderDialog)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif // !defined(AFX_BROSEFOLDERDIALOG_H__20040211_UEYAMA__INCLUDED_)
