#if !defined(AFX_LIGHTPHOTOSYNTHESISDLG_H__8C3D198D_1D8C_4643_AA64_97A05250C36C__INCLUDED_)
#define AFX_LIGHTPHOTOSYNTHESISDLG_H__8C3D198D_1D8C_4643_AA64_97A05250C36C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// LightPhotosynthesisDlg.h : wb_[ t@C
//
#pragma warning( disable : 4786 )
#include "MeanTerm.h"
#include <vector>

/////////////////////////////////////////////////////////////////////////////
// CLightPhotosynthesisDlg _CAO

class CLightPhotosynthesisDlg : public CDialog
{
// RXgNV
public:
	CLightPhotosynthesisDlg(CWnd* pParent = NULL);   // W̃RXgN^
	~CLightPhotosynthesisDlg();

// _CAO f[^
	//{{AFX_DATA(CLightPhotosynthesisDlg)
	enum { IDD = IDD_LIGHT_PHOTOSYNTHESIS };
	UINT	m_iDaysOfTerm;
	CString	m_strInputFile;
	CString	m_strOutputFile;
	UINT	m_iRunPerDay;
	BOOL	m_bSetMaximumB;
	double	m_dMaximumB;
	BOOL	m_bCalculateR0;
	BOOL	m_bUseNegativeValues;
	BOOL	m_bUseNonRectangular;
	double	m_dConvexity;
	CString	m_strInputFile1;
	CString	m_strInputFile2;
	CString	m_strOutputApplicationFile;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CLightPhotosynthesisDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	CString m_strInputTitle;

	// Œp^
	std::vector<CPhotosynthesisParameters> m_aryFixedPhotosynthesisParameters;
	std::vector<CRespirationParameters> m_aryFixedRespirationParameters;

	BOOL ReadFileByMeanTerm(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iDaysOfTerm, CString& strHeaderLine, BOOL bExistHeader = TRUE);

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CLightPhotosynthesisDlg)
	afx_msg void OnExec();
	afx_msg void OnButtonInputFile();
	afx_msg void OnButtonOutputFile();
	afx_msg void OnKillfocusEdit();
	afx_msg void OnCheckMaxB();
	virtual BOOL OnInitDialog();
	afx_msg void OnCheckCalcR0();
	afx_msg void OnCheckNegativeValue();
	afx_msg void OnCheckNonRectangular();
	afx_msg void OnKillfocus();
	afx_msg void OnDestroy();
	afx_msg void OnButtonInputFile1();
	afx_msg void OnButtonInputFile2();
	afx_msg void OnButtonOutputApplication();
	afx_msg void OnButtonExecApplication();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_LIGHTPHOTOSYNTHESISDLG_H__8C3D198D_1D8C_4643_AA64_97A05250C36C__INCLUDED_)
