#if !defined(AFX_LOOKUPTABLEDLG_H__3FC32C0C_8B29_4236_A89E_28FC002F0260__INCLUDED_)
#define AFX_LOOKUPTABLEDLG_H__3FC32C0C_8B29_4236_A89E_28FC002F0260__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// LookUpTableDlg.h : wb_[ t@C
//
#include "MeanTerm.h"
#include <vector>
/////////////////////////////////////////////////////////////////////////////
// CLookUpTableDlg _CAO

class CLookUpTableDlg : public CDialog
{
// RXgNV
public:
	CLookUpTableDlg(CWnd* pParent = NULL);   // W̃RXgN^
	CString m_strInputTitle;

	void SetForBatchSetting(const CString& strIniFile, const CString& strInputFile, const CString& strOutputDir);

	BOOL OnLookUpTable(CString& strErrorMessage);

// _CAO f[^
	//{{AFX_DATA(CLookUpTableDlg)
	enum { IDD = IDD_DLG_LUT };
	CProgressCtrl	m_ctlProgress;
	UINT	m_iGapFillingTerm;
	UINT	m_iRunPerDay;
	CString	m_strInputFile;
	CString	m_strOutputFile;
	BOOL	m_bUseLinearRegression;
	BOOL	m_bUsePeriod;
	BOOL	m_bMovingAverage;
	UINT	m_iMaximumForLinearRegression;
	UINT	m_iCalibrationColmun1;
	UINT	m_iCalibrationColmun2;
	UINT	m_iCalibrationColmun3;
	UINT	m_iApplicationColmun1;
	UINT	m_iApplicationColmun2;
	UINT	m_iApplicationColmun3;
	UINT	m_iDivide1;
	UINT	m_iDivide2;
	UINT	m_iDivide3;
	double	m_dMax1;
	double	m_dMax2;
	double	m_dMax3;
	double	m_dMin1;
	double	m_dMin2;
	double	m_dMin3;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CLookUpTableDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	BOOL ErrorCheck(CString& strErrorMessage);
	BOOL ReadFile_with_MovingWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm, CString& strHeaderLine);
	BOOL ReadFile_with_BlockWindow(CString& strInputFile, std::vector<CMeanTerm*>& aryMeanTerm, int iRunPerDay, int iPhotosynthesisTerm, CString& strHeaderLine);
	BOOL LookUpTable(const CString& strOutDir, std::vector<CMeanTerm*>& aryMeanTerm, CString& strHeaderLine, BOOL bMovingAverage, CProgressCtrl& ctlProgress);

	CWinThread* m_pThread;
	BOOL m_bIsThread;
	static UINT OnLookUpTableThread(LPVOID pParam);
	CString m_strErrorMessageForThread;

	void SaveSetting(const CString& strFilePass);
	BOOL SetParameterFromFile(CString strFilePass);

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CLookUpTableDlg)
	afx_msg void OnKillfocus();
	afx_msg void OnButtonInputFile();
	afx_msg void OnButtonOutDir();
	afx_msg void OnButtonApply();
	afx_msg void OnCheckUseRegression();
	virtual BOOL OnInitDialog();
	afx_msg void OnCheckPeriod();
	afx_msg void OnCheckMovingWd();
	afx_msg void OnBtnSave();
	afx_msg void OnBtnLaod();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_LOOKUPTABLEDLG_H__3FC32C0C_8B29_4236_A89E_28FC002F0260__INCLUDED_)
