// FluxAnalysisToolDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FluxAnalysisTool.h"
#include "FluxAnalysisToolDlg.h"

#include "LightPhotosynthesisDlg.h"
#include "FluxPartitioningDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFluxAnalysisToolDlg _CAO

CFluxAnalysisToolDlg::CFluxAnalysisToolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFluxAnalysisToolDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFluxAnalysisToolDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_dlgMDV = NULL;
	m_dlgFluxPartitioning = NULL;
	m_dlgUstarFiltering = NULL;
	m_dlgLookUpTable = NULL;
	m_dlgQcQa = NULL;
	m_dlgBatch = NULL;
	m_dlgSelfCorrelation = NULL;
}

CFluxAnalysisToolDlg::~CFluxAnalysisToolDlg()
{
	if(m_dlgMDV != NULL) delete m_dlgMDV;
	if(m_dlgFluxPartitioning != NULL) delete m_dlgFluxPartitioning;
	if(m_dlgUstarFiltering != NULL) delete m_dlgUstarFiltering;
	if(m_dlgLookUpTable != NULL) delete m_dlgLookUpTable;
	if(m_dlgQcQa != NULL) delete m_dlgQcQa;
	if(m_dlgBatch != NULL) delete m_dlgBatch;
}

void CFluxAnalysisToolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFluxAnalysisToolDlg)
	DDX_Control(pDX, IDC_BTN_SELF_CORREL, m_buttonSelfCorrelation);
	DDX_Control(pDX, IDC_BTN_QC, m_bottonQC);
	DDX_Control(pDX, IDC_BTN_BATCH, m_buttonBATCH);
	DDX_Control(pDX, IDC_BTN_LUT, m_buttonLUT);
	DDX_Control(pDX, IDC_BTN_GAP_FILL, m_buttonGapFill);
	DDX_Control(pDX, IDC_BTN_U_STAR, m_bottonUstar);
	DDX_Control(pDX, IDC_BTN_MDV, m_bottonMDV);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFluxAnalysisToolDlg, CDialog)
	//{{AFX_MSG_MAP(CFluxAnalysisToolDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_MENU_LIGHT_PHOTOSYNTHESIS, OnMenuMeanDiurnalVariation)
	ON_COMMAND(ID_MENU_FLUX_PARTITIONING, OnMenuFluxPartitioning)
	ON_COMMAND(ID_MENU_USTAR_FILTERING, OnMenuUstarFiltering)
	ON_BN_CLICKED(IDC_BTN_U_STAR, OnBtnUStar)
	ON_BN_CLICKED(IDC_BTN_MDV, OnBtnMdv)
	ON_BN_CLICKED(IDC_BTN_GAP_FILL, OnBtnGapFill)
	ON_COMMAND(ID_MENU_LOOK_UP_TABLE, OnMenuLookUpTable)
	ON_BN_CLICKED(IDC_BTN_LUT, OnBtnLUT)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_BN_CLICKED(IDC_BTN_BATCH, OnBtnBatch)
	ON_COMMAND(ID_MENU_BATCH, OnMenuBatch)
	ON_COMMAND(ID_MENU_HELP, OnMenuHelp)
	ON_COMMAND(ID_MENU_HELP_EN, OnMenuHelpEn)
	ON_COMMAND(ID_MENU_QC, OnMenuQC)
	ON_BN_CLICKED(IDC_BTN_QC, OnBtnQC)
	ON_COMMAND(ID_MENU_SELF_CORREL, OnMenuSelfCorrel)
	ON_BN_CLICKED(IDC_BTN_SELF_CORREL, OnBtnSelfCorrel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFluxAnalysisToolDlg bZ[W nh

BOOL CFluxAnalysisToolDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ

	CWinApp* pApp = AfxGetApp();
	HICON hFile = pApp->LoadIcon( IDR_MAINFRAME );
	m_buttonGapFill.SetIcon ( hFile );

	hFile = pApp->LoadIcon( IDI_MDV );
	m_bottonMDV.SetIcon ( hFile );

	hFile = pApp->LoadIcon( IDI_U_STAR );
	m_bottonUstar.SetIcon ( hFile );
	
	hFile = pApp->LoadIcon( IDI_LUT );
	m_buttonLUT.SetIcon ( hFile );

	hFile = pApp->LoadIcon( IDI_QC );
	m_bottonQC.SetIcon ( hFile );

	hFile = pApp->LoadIcon( IDI_BATCH );
	m_buttonBATCH.SetIcon ( hFile );

	hFile = pApp->LoadIcon( IDI_CORREL );
	m_buttonSelfCorrelation.SetIcon ( hFile );

	// TODO: ʂȏs͂̏ꏊɒǉĂB
	// OnMenuLightPhotosynthesis();
	// OnMenuFluxPartitioning();
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CFluxAnalysisToolDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CFluxAnalysisToolDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CFluxAnalysisToolDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFluxAnalysisToolDlg::OnAppAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void CFluxAnalysisToolDlg::OnMenuMeanDiurnalVariation() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_dlgMDV == NULL){
		m_dlgMDV = new CMenuMeanDiurnalVariationDlg;
		m_dlgMDV->Create(IDD_DLG_MDV, this);
		m_dlgMDV->ShowWindow(SW_SHOW);
	}
	else{
		m_dlgMDV->ShowWindow(SW_SHOW);
	}
}

void CFluxAnalysisToolDlg::OnMenuFluxPartitioning() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_dlgFluxPartitioning == NULL){
		m_dlgFluxPartitioning = new CFluxPartitioningDlg;
		m_dlgFluxPartitioning->Create(IDD_DLG_FLUX_PARTITION, this);
		m_dlgFluxPartitioning->ShowWindow(SW_SHOW);
	}
	else{
		m_dlgFluxPartitioning->ShowWindow(SW_SHOW);
	}
}

void CFluxAnalysisToolDlg::OnMenuUstarFiltering() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_dlgUstarFiltering == NULL){
		m_dlgUstarFiltering = new CUstarFilteringDlg;
		m_dlgUstarFiltering->Create(IDD_DLG_U_STAR, this);
		m_dlgUstarFiltering->ShowWindow(SW_SHOW);
	}
	else{
		m_dlgUstarFiltering->ShowWindow(SW_SHOW);
	}
}

void CFluxAnalysisToolDlg::OnMenuLookUpTable() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_dlgLookUpTable == NULL){
		m_dlgLookUpTable = new CLookUpTableDlg;
		m_dlgLookUpTable->Create(IDD_DLG_LUT, this);
		m_dlgLookUpTable->ShowWindow(SW_SHOW);
	}
	else{
		m_dlgLookUpTable->ShowWindow(SW_SHOW);
	}

}

void CFluxAnalysisToolDlg::OnMenuQC() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_dlgQcQa == NULL){
		m_dlgQcQa = new CQcQaDlg;
		m_dlgQcQa->Create(IDD_DLG_QC, this);
		m_dlgQcQa->ShowWindow(SW_SHOW);
	}
	else{
		m_dlgQcQa->ShowWindow(SW_SHOW);
	}
	
}

void CFluxAnalysisToolDlg::OnMenuBatch() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_dlgBatch == NULL){
		m_dlgBatch = new CBatchDlg;
		m_dlgBatch->Create(IDD_DLG_BATCH, this);
		m_dlgBatch->ShowWindow(SW_SHOW);
		m_dlgBatch->SetDlgPoint(this);
	}
	else{
		m_dlgBatch->ShowWindow(SW_SHOW);
	}
}

void CFluxAnalysisToolDlg::OnMenuSelfCorrel() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_dlgSelfCorrelation == NULL){
		m_dlgSelfCorrelation = new CSelfCorrelationDlg;
		m_dlgSelfCorrelation->Create(IDD_DLG_SELF_CORREL, this);
		m_dlgSelfCorrelation->ShowWindow(SW_SHOW);
	}
	else{
		m_dlgSelfCorrelation->ShowWindow(SW_SHOW);
	}
}

void CFluxAnalysisToolDlg::OnBtnUStar() 
{
	OnMenuUstarFiltering();
}

void CFluxAnalysisToolDlg::OnBtnMdv() 
{
	OnMenuMeanDiurnalVariation() ;
}

void CFluxAnalysisToolDlg::OnBtnGapFill() 
{
	OnMenuFluxPartitioning() ;
}

void CFluxAnalysisToolDlg::OnBtnLUT() 
{
	OnMenuLookUpTable();
}

void CFluxAnalysisToolDlg::OnBtnBatch() 
{
	OnMenuBatch();
}

void CFluxAnalysisToolDlg::OnBtnQC() 
{
	OnMenuQC();
}

void CFluxAnalysisToolDlg::OnBtnSelfCorrel() 
{
	OnMenuSelfCorrel();
}

void CFluxAnalysisToolDlg::OnMenuHelp() 
{
	CString strFn = GetModuleDirectory();
	strFn = strFn + "\\FAT_Help.chm";

	ShellExecute(NULL,"open",strFn, NULL, NULL, SW_SHOWNORMAL);	
}

void CFluxAnalysisToolDlg::OnMenuHelpEn() 
{
	CString strFn = GetModuleDirectory();
	strFn = strFn + "\\FAT_Help_EN.chm";

	ShellExecute(NULL,"open",strFn, NULL, NULL, SW_SHOWNORMAL);	
}

CString CFluxAnalysisToolDlg::GetModuleDirectory()
{
	char lpszFn[CHAR_MAX];
	DWORD bufsize = (DWORD) sizeof(lpszFn);

	memset(lpszFn,0x00,sizeof(lpszFn));
	GetModuleFileName(NULL,lpszFn,bufsize);
	
	CString strFn = lpszFn;
	strFn.TrimRight();
	int index = strFn.ReverseFind('\\');
	strFn = strFn.Left(index);

	return strFn;
}
