// FluxAnalysisToolDlg.h : wb_[ t@C
//

#if !defined(AFX_FLUXANALYSISTOOLDLG_H__3A81BF90_3C29_4F85_86AF_40EBAFB6028C__INCLUDED_)
#define AFX_FLUXANALYSISTOOLDLG_H__3A81BF90_3C29_4F85_86AF_40EBAFB6028C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MenuMeanDiurnalVariationDlg.h"
#include "FluxPartitioningDlg.h"
#include "UstarFilteringDlg.h"
#include "LookUpTableDlg.h"
#include "QcQaDlg.h"
#include "BatchDlg.h"
#include "SelfCorrelationDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CFluxAnalysisToolDlg _CAO
class CBatchDlg;

class CFluxAnalysisToolDlg : public CDialog
{
// \z
public:
	CFluxAnalysisToolDlg(CWnd* pParent = NULL);	// W̃RXgN^
	CFluxAnalysisToolDlg::~CFluxAnalysisToolDlg();

// _CAO f[^
	//{{AFX_DATA(CFluxAnalysisToolDlg)
	enum { IDD = IDD_FLUXANALYSISTOOL_DIALOG };
	CButton	m_buttonSelfCorrelation;
	CButton	m_bottonQC;
	CButton	m_buttonBATCH;
	CButton	m_buttonLUT;
	CButton	m_buttonGapFill;
	CButton	m_bottonUstar;
	CButton	m_bottonMDV;
	//}}AFX_DATA

	void public_OnMenuFluxPartitioning(){OnMenuFluxPartitioning();}
	void public_OnMenuMeanDiurnalVariation(){OnMenuMeanDiurnalVariation();}
	void public_OnMenuLookUpTable(){OnMenuLookUpTable();}
	void public_OnMenuUstarFiltering(){OnMenuUstarFiltering();}
	void public_OnMenuQC(){OnMenuQC();}

	CMenuMeanDiurnalVariationDlg* m_dlgMDV;
	CFluxPartitioningDlg* m_dlgFluxPartitioning;
	CUstarFilteringDlg* m_dlgUstarFiltering;
	CLookUpTableDlg* m_dlgLookUpTable;
	CQcQaDlg* m_dlgQcQa;
	CBatchDlg* m_dlgBatch;
	CSelfCorrelationDlg* m_dlgSelfCorrelation;
	
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CFluxAnalysisToolDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	CString GetModuleDirectory();

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CFluxAnalysisToolDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnMenuMeanDiurnalVariation();
	afx_msg void OnMenuFluxPartitioning();
	afx_msg void OnMenuUstarFiltering();
	afx_msg void OnBtnUStar();
	afx_msg void OnBtnMdv();
	afx_msg void OnBtnGapFill();
	afx_msg void OnMenuLookUpTable();
	afx_msg void OnBtnLUT();
	afx_msg void OnAppAbout();
	afx_msg void OnBtnBatch();
	afx_msg void OnMenuBatch();
	afx_msg void OnMenuHelp();
	afx_msg void OnMenuHelpEn();
	afx_msg void OnMenuQC();
	afx_msg void OnBtnQC();
	afx_msg void OnMenuSelfCorrel();
	afx_msg void OnBtnSelfCorrel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_FLUXANALYSISTOOLDLG_H__3A81BF90_3C29_4F85_86AF_40EBAFB6028C__INCLUDED_)
